try:
    import xbmcgui
    import xbmc
except:
    from dev.xbmclib import xbmcgui
    from dev.xbmclib import xbmc

class InputWindow(xbmcgui.WindowDialog):
    cptloc = None
    
    def __init__(self, *args, **kwargs):
        self.cptloc = kwargs.get('captcha',None)
        if self.cptloc != None:
            self.img = xbmcgui.ControlImage(335, 30, 624, 60, self.cptloc)
            self.addControl(self.img)
        self.kbd = xbmc.Keyboard()

    def get(self):
        self.show()
        self.kbd.doModal()
        if (self.kbd.isConfirmed()):
            text = self.kbd.getText()
            self.close()
            return text
        self.close()
        return False
