try:
    import xbmc
    import xbmcgui
except:
    from dev.xbmclib import xbmc
    from dev.xbmclib import xbmcgui
from lib import IPhoenix

class WaitDialog(xbmcgui.DialogProgress):      
        
    def wait(self, seconds, title, text="Wait %s seconds"):
        if seconds > 0:
            IPhoenix.logDebug('waiting '+str(seconds)+' secs')
            self.create(str(title))
            secs=0
            percent=0
            increment = float(100) / seconds
            increment = int(round(increment))
            cancelled = False
            while secs < seconds:
                secs = secs + 1
                percent = increment*secs
                secs_left = str((seconds - secs))
                self.update(percent,str(text % secs_left))
                xbmc.sleep(1000)
                if (self.iscanceled()):
                    cancelled = True
                    break
            if cancelled == True:
                self.close()
                IPhoenix.logDebug('wait cancelled')
                return False
            else:
                self.close()
                IPhoenix.logDebug('done waiting')
                return True
        