import urllib
from urlparse import urlparse
from resolver import IResolver, HosterException, StreamOfflineException
from lib.FormParser import *
from lib import JSUnpacker


class Hoster(IResolver):
    domain = "uploadc.com"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            up = urlparse(url)
            # set mid
            self.setMID(up.path[1:])
            if "embed-" in self.getMID():
                # set mid
                self.setMID(re.search("embed-([a-zA-Z0-9]+)",self.getMID()).group(1))
            # set clean url
            self.setURL("http://www.%s/%s"%(self.domain,self.getMID()))
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))
        
    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/%s" % (self.domain,self.getMID()))
            self.addHeader("Referer","http://www.%s/%s" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)       
            form = s("form",limit=1)
            if(len(form)>0):
                formFields = getFormFields(form)
                formFields["method_free"]="Slow access"
                response = self.opener.open("http://www.%s/%s" % (self.domain,self.getMID()),urllib.urlencode(formFields))
                html = response.read()
                lunpacked = JSUnpacker.extract(html)
                for unpacked in lunpacked:
                    obj = re.findall("(<object.*?object>)",unpacked)
                    if len(obj) > 0:
                        s = BeautifulStoneSoup(obj[0])
                        param = s("param",attrs= {"name":"src"})
                        if len(param) > 0:
                            return param[0]["value"]
                raise HosterException('0x2 not resovlable')
            elif "File Not Found" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
