import re
from lib.BeautifulSoup import BeautifulStoneSoup

def getFormFields(form):
    retVal = {}
    f = BeautifulStoneSoup(str(form))
    inputs = f("input",attrs={"name":re.compile(".+"),"type":re.compile("text|hidden|password|submit|image",re.I)})
    checkboxes = f("input",attrs={"name":re.compile(".+"),"type":re.compile("checkbox|radio",re.I),"checked":"checked"})
    textareas = f("textarea",attrs={"name":re.compile(".+")})
    select = f("option",attrs={"checked":re.compile("checked",re.I)})

    for i in inputs:
        retVal[i.get("name","")]=i.get("value","")
    for i in checkboxes:
        retVal[i.get("name","")]=i.get("value","")
    for i in textareas:
        retVal[i.get("name","")]=i.contents[0]
    for i in select:
        retVal[i.parent.get("name","")]=i.get("value","")
    return retVal
