import re
from resolver import IResolver, HosterException 
from lib.BeautifulSoup import BeautifulStoneSoup

# TODO: Hoster offline => NO Unittest
class Hoster(IResolver):
    domain = "skyload.net"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/file/([^&|^\/|^\?]+)\.flv|file_id=([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setupURL("")
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/index.php?seite=file&file_id=%s&go=1" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            swfobject = s(text=re.compile("file=http[^'|^\"]+",re.I))
            if(len(swfobject) > 0):
                url = re.search("file=(http[^'|^\"]+)",swfobject[0],re.I)
                if(url != None):
                    return url.group(1)
                else:
                    raise HosterException('0x0 not resovlable')
            else:
                raise HosterException('0x1 not resovlable')
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
