import re
from urlparse import urlparse
from resolver import IResolver ,HosterException
from lib.BeautifulSoup import BeautifulStoneSoup

# TODO: Hoster offline => NO Unittest
class Hoster(IResolver):
    domain = "stream2k.com"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('vkey=([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://%s/playerjw/vConfig56.php?vkey=%s" % (urlparse(self.getURL()).netloc,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            return  s.config.file.contents[0]
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
